Skip to main content
Sora 2 is an AI model from OpenAI that creates realistic and imaginative video scenes from text instructions and/or input images or video. The model can generate a wide range of video content, including realistic scenes, animations, and special effects. It supports several video resolutions and durations.

Capabilities

  • Modalities: text → video, image → video, video (generated) → video
  • Audio: Sora 2 supports audio generation in output videos (similar to the Sora app).
  • Remix: Sora 2 introduces the ability to remix existing videos by making targeted adjustments instead of regenerating from scratch.
  • Responsible AI and video generation: Azure OpenAI’s video generation models include built-in Responsible AI (RAI) protections to help ensure safe and compliant use. Sora 2 blocks all IP and photorealistic content. In addition, Azure provides input and output moderation across all image generation models, along with Azure-specific safeguards such as content filtering and abuse monitoring. These systems help detect and prevent the generation or misuse of harmful, unsafe, or policy-violating content. Customers can learn more about these safeguards and how to customize them on the Content filtering page.

Model details

Sora 2 uses the Azure OpenAI v1 API, aligning with OpenAI’s native Sora 2 schema.

Quickstart

Generate video clips using the Azure OpenAI service. Video generation is an asynchronous process. You create a job request with your text prompt and video format specifications, and the model processes the request in the background. You check the status of the video generation job and, once it finishes, retrieve the generated video through a download URL. The example uses the Sora 2 model.

Clean up resources

If you want to clean up and remove an Azure OpenAI resource, you can delete the resource. Before deleting the resource, you must first delete any deployed models.

Responsible AI and video generation

Azure OpenAI’s image generation models include built-in Responsible AI (RAI) protections to help ensure safe and compliant use. In addition, Azure provides input and output moderation across all image generation models, along with Azure-specific safeguards such as content filtering and abuse monitoring. These systems help detect and prevent the generation or misuse of harmful, unsafe, or policy-violating content. Currently the Sora 2 API enforces several content restrictions:
  • Only content suitable for audiences under 18 (a setting to bypass this restriction will be available in the future).
  • Copyrighted characters and copyrighted music will be rejected.
  • Real people—including public figures—cannot be generated.
  • Input images with faces of humans are currently rejected.
Make sure prompts, reference images, and transcripts respect these rules to avoid failed generations.

Sora 2 API reference

The Sora 2 API provides 5 endpoints, each with distinct capabilities.
  • Create Video: Start a new render job from a prompt, with optional reference inputs or a remix ID.
  • Get Video Status: Retrieve the current state of a render job and monitor its progress
  • Download Video: Fetch the finished MP4 once the job is completed.
  • List Videos: Enumerate your videos with pagination for history, dashboards, or housekeeping.
  • Delete Videos: Delete an individual video ID from Azure OpenAI’s storage

API parameters

Sora 2 API uses the v1 API and has the same structure as the OpenAI API.

videos.create()

You’ll need to update to the latest version of the OpenAI client with pip install openai --upgrade to prevent AttributeError: 'OpenAI' object has no attribute 'videos'.

Create a video and poll job status

Call GET /videos/{video_id} with the ID returned from the create call. The response shows the job’s current status, progress percentage, and any errors. Expected states are queued, in_progress, completed, and failed.
Synchronous:Use this version if testing in Jupyter Notebooks to avoid RuntimeError: asyncio.run() cannot be called from a running event loop
Async:

Download video

Video generation from reference source

The input_reference parameter allows you to transform existing images using Sora 2. The resolution of the source image and final video must match. Supported values are 720x1280, and 1280x720.
Local reference file:
URL based reference file:

Remix video

The remix feature allows you to modify specific aspects of an existing video while preserving its core elements. By referencing the previous video id from a successfully completed generation, and supplying an updated prompt the system maintains the original video’s framework, scene transitions, and visual layout while implementing your requested changes. For optimal results, limit your modifications to one clearly articulated adjustment—narrow, precise edits retain greater fidelity to the source material and minimize the likelihood of generating visual defects.

Best practices for prompts

Write text prompts in English or other Latin script languages for the best video generation performance.

Limitations

Content quality limitations

Sora 2 might have difficulty with complex physics, causal relationships (for example, bite marks on a cookie), spatial reasoning (for example, knowing left from right), and precise time-based event sequencing such as camera movement.

Technical limitations

Sora 2 video generation is currently in preview. Keep the following limitations in mind:
  • Sora 2 supports the following output resolution dimensions: 480x480, 480x854, 854x480, 720x720, 720x1280, 1280x720, 1080x1080, 1080x1920, 1920x1080.
  • Sora 2 can produce videos between 1 and 20 seconds long.
  • You can request multiple video variants in a single job: for 1080p resolutions, this feature is disabled; for 720p, the maximum is two variants; for other resolutions, the maximum is four variants.
  • You can have two video creation jobs running at the same time. You must wait for one of the jobs to finish before you can create another.
  • Jobs are available for up to 24 hours after they’re created. After that, you must create a new job to generate the video again.
  • You can use up to two images as input (the generated video interpolates content between them).
  • You can use one video up to five seconds as input.